<?php

/***

Sciurus - Bérenger THOMAS
28.03.15

Ajout/modifications de fichiers et dossiers

*/

require_once 'library/main.php';
require_once 'library/header.php';



// INITIALISATION

$id = (isset($_GET['id']) AND intval($_GET['id']) > 0) ? intval($_GET['id']) : 1;
$edit = $del = FALSE;
$arboBrute = $arboParents = array();

if($_SESSION['admin'])
{
	if(isset($_GET['edit']) OR isset($_GET['del']))
	{
		if(isset($_GET['edit'])){ $edit = TRUE; }
		if(isset($_GET['del'])){ $del = TRUE; }
		if(isset($_GET['f']) AND intval($_GET['f']) > 0){ $f = intval($_GET['f']); }
		if(isset($_GET['d'])){ $d = (intval($_GET['d']) > 0) ? intval($_GET['d']) : 0; }
	}
	else
	{
		if(isset($_GET['d'])){ $d = 0; }
	}
}



// DOSSIER

if(isset($d))
{
	if($del AND $d > 1)
	{
		$sql = 'DELETE FROM dossier WHERE id = :id';
		$req = $db->prepare($sql);
		$req->bindValue('id', $d, PDO::PARAM_INT);
	
		if($req->execute())
		{
			redirection('index.php?id='.$id, 'Dossier supprimé.');
		}
		else
		{
			redirection('index.php?id='.$id, 'Une erreur est survenue.');
		}
	}
	else if(isset($_POST['nom']))
	{
		$nom = $_POST['nom'];
		$parent = intval($_POST['parent']);
		
		if($edit AND $d > 1)
		{
			$sql = 'UPDATE dossier SET nom = :nom, parent = :parent WHERE id = :id';
			$req = $db->prepare($sql);
			$req->bindValue('nom', $nom, PDO::PARAM_STR);
			$req->bindValue('parent', $parent, PDO::PARAM_INT);
			$req->bindValue('id', $d, PDO::PARAM_INT);
			
			if($req->execute())
			{
				redirection('index.php?id='.$id, 'Modifications enregistrées.');
			}
			else
			{
				errReq($sql, $req);
				redirection('add.php?d='.$d.'&id='.$id, 'Une erreur est survenue.');
			}
		}
		else
		{
			$sql = 'INSERT INTO dossier	(nom,	parent)
								VALUES	(:nom,	:parent)';
			$req = $db->prepare($sql);
			$req->bindValue('nom', $nom, PDO::PARAM_STR);
			$req->bindValue('parent', $parent, PDO::PARAM_INT);
	
			if($req->execute())
			{
				redirection('index.php?id='.$id, 'Dossier ajouté.');
			}
			else
			{
				errReq($sql, $req);
				redirection('add.php?d&id='.$id, 'Une erreur est survenue.');
			}
		}
	}
}



// FICHIER SUPPRESSION

else if($del AND isset($f))
{
	$sql = 'SELECT extension FROM fichier WHERE id = :id LIMIT 1';
	$req = $db->prepare($sql);
	$req->bindValue('id', $f, PDO::PARAM_INT);
	
	if($req->execute())
	{
		if($res = $req->fetch())
		{
			$sql = 'DELETE FROM fichier WHERE id = :id';
			$req = $db->prepare($sql);
			$req->bindValue('id', $f, PDO::PARAM_INT);
	
			if($req->execute())
			{
				if(is_file('upload/'.$f.'.'.$res['extension']))
				{
					unlink('upload/'.$f.'.'.$res['extension']);
				}
				
				redirection('index.php?id='.$id, 'Fichier supprimé.');
			}
			else
			{
				errReq($sql, $req);
			}
		}
	}
	else
	{
		errReq($sql, $req);
	}
	
	redirection('index.php?id='.$id, 'Une erreur est survenue.');
}



// FICHIER MODIFICATION / AJOUT

else if(!empty($_POST['dossier']) AND (!ONLY_ADMIN_ADD OR $_SESSION['admin']))
{
	$description = (isset($_POST['description'])) ? $_POST['description'] : '';
	$auteur = (isset($_POST['auteur'])) ? $_POST['auteur'] : '';
	$dossier = (intval($_POST['dossier']) > 0) ? intval($_POST['dossier']) : '1';
	
	if($edit AND isset($f) AND !empty($_POST['nom']))
	{
		$nom = $_POST['nom'];
		
		$sql = 'UPDATE fichier SET nom = :nom, description = :description, dossier = :dossier, auteur = :auteur WHERE id = :id';
		$req = $db->prepare($sql);
		$req->bindValue('nom', $nom, PDO::PARAM_STR);
		$req->bindValue('description', $description, PDO::PARAM_STR);
		$req->bindValue('auteur', $auteur, PDO::PARAM_STR);
		$req->bindValue('dossier', $dossier, PDO::PARAM_INT);
		$req->bindValue('id', $f, PDO::PARAM_INT);
		
		if($req->execute())
		{
			redirection('index.php?id='.$id, 'Modifications enregistrées.');
		}
		else
		{
			redirection('add.php?id='.$id.'&edit&f='.$f, 'Une erreur est survenue lors de la modification.');
		}
	}
	else if(isset($_FILES['fichier']))
	{
		$file = $_FILES['fichier'];
		$uploadDir = 'upload/';
		
		if($file['error'] > 0)
		{
			redirection('add.php?id='.$id, 'Une erreur est survenue, merci de réessayer.');
		}
		else
		{
			if($file['size'] > FICHIER_TAILLE_MAX*1024*1024)
			{
				redirection('add.php?id='.$id, 'Le fichier est trop lourd. Taille maximale autorisée : '.FICHIER_TAILLE_MAX.' Mo.');
			}
			else
			{
				if(mb_strlen($file['name']) > 100)
				{
					redirection('add.php?id='.$id, 'Le nom du fichier est trop long.');
				}
				else
				{
					$fichierNom = array();
					preg_match('#(.+)\.([^\.]+)$#i', $file['name'], $fichierNom);
					
					
					if(count($fichierNom) == 3)
					{
						$sql = 'INSERT INTO fichier (nom, 	extension, 	description, 	dossier, 	taille, 	telechargement, 	date, 	plus, 	moins, 	auteur, 	ip, 	validation)
											VALUES	(:nom, 	:ext,		:description,	:dossier,	:taille,	0,					NOW(),	0,		0,		:auteur,	:ip,	0)';
						$req = $db->prepare($sql);
						
						$req->bindValue('nom', $fichierNom[1], PDO::PARAM_STR);
						$req->bindValue('ext', strtolower($fichierNom[2]), PDO::PARAM_STR);
						$req->bindValue('description', $description, PDO::PARAM_STR);
						$req->bindValue('dossier', $dossier, PDO::PARAM_INT);
						$req->bindValue('taille', $file['size'], PDO::PARAM_STR);
						$req->bindValue('auteur', $auteur, PDO::PARAM_STR);
						$req->bindValue('ip', $_SERVER['SERVER_ADDR'], PDO::PARAM_STR);
						
						if($req->execute())
						{
							$fichierId = $db->lastInsertId();
						
							if(move_uploaded_file($file['tmp_name'], $uploadDir.$fichierId.'.'.strtolower($fichierNom[2])))
							{
								redirection('index.php?id='.$id, 'Fichier ajouté.');
							}
							else
							{
								redirection('add.php?id='.$id, 'Un problème est survenu, merci de réessayer.');
							}
						}
						else
						{
							redirection('add.php?id='.$id, 'Un problème est survenu, merci de réessayer.');
						}
					}
					else
					{
						redirection('add.php?id='.$id, 'Un problème est survenu, merci de réessayer.');
					}
				}
			}
		}
	}
}



// AFFICHAGE

?>
<div id="corps">

<?php

if(isset($d))
{
	if($edit AND $d > 1)
	{
		$sql = 'SELECT nom, parent FROM dossier WHERE id = :id LIMIT 1';
		$req = $db->prepare($sql);
		$req->bindValue('id', $d, PDO::PARAM_INT);
		
		if($req->execute())
		{
			$res = $req->fetch();
		}
		else
		{
			errReq($sql, $req);
			redirection('index.php?id='.$id, 'Une erreur est survenue.');
		}
		
		?>
		
		<h2>Modifier un dossier</h2>
		
		<div id="option"><a href="index.php?id=<?php echo $id; ?>">Retour au dossier</a><br><br></div>
		
		<form method="POST" action="add.php?edit&d=<?php echo $d; ?>&id=<?php echo $id; ?>">
			<label for="nom">Nom du dossier</label>
			<input type="text" id="nom" name="nom" required value="<?php echo $res['nom']; ?>">
			<br>
			<label for="parent">Dossier parent</label>
			<select id="parent" name="parent" required>
				<?php
				$arbo = arborescence(0, $arboBrute, $arboParents);
				
				foreach($arbo AS $k => $a)
				{
					echo '<option value="'.$k.'"'; 
					if($k == $res['parent']){ echo ' selected'; }
					echo '>'.$a.'</option>';
				}
				?>
			</select>
			<br>
			<input type="submit" value="Enregistrer les modifications">
		</form>
		
		<?php
	}
	else
	{
		?>
		
		<h2>Ajouter un dossier</h2>
		
		<div id="option"><a href="index.php?id=<?php echo $id; ?>">Retour au dossier</a><br><br></div>
		
		<form method="POST" action="add.php?d&id=<?php echo $id; ?>">
			<label for="nom">Nom du dossier</label>
			<input type="text" id="nom" name="nom" required>
			<br>
			<label for="parent">Dossier parent</label>
			<select id="parent" name="parent" required>
				<?php 
				$arbo = arborescence(0, $arboBrute, $arboParents);
			
				foreach($arbo AS $k => $a)
				{
					echo '<option value="'.$k.'"';
					if($k == $id){ echo ' selected'; }
					echo '>'.$a.'</option>';
				}
				?>
			</select>
			<br>
			<input type="submit" value="Ajouter le dossier">
		</form>
		
		<?php
	}
}
else if(!ONLY_ADMIN_ADD OR $_SESSION['admin'])
{
	if($edit AND isset($f))
	{
		$sql = 'SELECT nom, description, dossier, auteur FROM fichier WHERE id = :id LIMIT 1';
		$req = $db->prepare($sql);
		$req->bindValue('id', $f, PDO::PARAM_INT);
		
		if($req->execute())
		{
			$res = $req->fetch();
		}
		else
		{
			errReq($sql, $req);
			redirection('index.php?id='.$id, 'Une erreur est survenue.');
		}
		
		?>
		
		<h2>Modifier un fichier</h2>
		
		<div id="option"><a href="index.php?id=<?php echo $id; ?>">Retour au dossier</a><br><br></div>
		
		<form method="POST" action="add.php?edit&id=<?php echo $id; ?>&f=<?php echo $f; ?>">
			<label for="nom">Nom du fichier</label>
			<input type="text" id="nom" name="nom" required value="<?php echo $res['nom']; ?>">
			<br>
			<label for="description">Description</label>
			<input type="text" id="description" name="description" value="<?php echo $res['description']; ?>">
			<br>
			<label for="auteur">Auteur</label>
			<input type="text" id="auteur" name="auteur" value="<?php echo $res['auteur']; ?>">
			<br>
			<label for="dossier">Dossier</label>
			<select id="dossier" name="dossier" required>
				<?php 
				$arbo = arborescence(0, $arboBrute, $arboParents);
			
				foreach($arbo AS $k => $a)
				{
					echo '<option value="'.$k.'"';
					if($k == $res['dossier']){ echo ' selected'; }
					echo '>'.$a.'</option>';
				}
				?>
			</select>
			<br>
			<input type="submit" value="Enregistrer les modifications">
		</form>
		
		<?php
	}
	else
	{
		?>
		
		<h2>Ajouter un fichier</h2>
		
		<div id="option"><a href="index.php?id=<?php echo $id; ?>">Retour au dossier</a><br><br></div>
		
		<form method="POST" action="add.php?id=<?php echo $id; ?>" enctype="multipart/form-data">
			<label for="fichier">Fichier (<?php echo FICHIER_TAILLE_MAX; ?> Mo max) : </label>
			<input type="file" id="fichier" name="fichier" required>
			<br><br>
			<label for="description">Description</label>
			<input type="text" id="description" name="description">
			<br>
			<label for="auteur">Auteur</label>
			<input type="text" id="auteur" name="auteur">
			<br>
			<label for="dossier">Dossier</label>
			<select id="dossier" name="dossier" required>
				<?php 
				$arbo = arborescence(0, $arboBrute, $arboParents);
				
				foreach($arbo AS $k => $a)
				{
					echo '<option value="'.$k.'"';
					if($k == $id){ echo ' selected'; }
					echo '>'.$a.'</option>';
				}
				?>
			</select>
			<br>
			<input type="submit" value="Ajouter le fichier">
		</form>
		
		<?php
	}
}
else
{
	echo '<p>Vous ne pouvez pas accéder à cette page.</p>';
}

?>
</div>
<?php
require_once 'library/footer.php';
?>

