<?php

/***

Sciurus - Bérenger THOMAS
28.03.15

Espace d'administration

*/


require_once 'library/main.php';
require_once 'library/header.php';



// INITIALISATION

$admin = FALSE;

if(isset($_GET['deconnexion']))
{
	session_destroy();
}
else if($_SESSION['admin'] OR (isset($_POST['login']) AND checkLogin() === TRUE))
{
	$admin = TRUE;
}

if(!isset($_GET['tri'])){ $_GET['tri'] = 'nom'; }



if($admin)
{
	
	// GESTION DES PARAMETRES
	
	if(isset($_GET['param']))
	{
		if(isset($_POST['siteNom']))
		{
			$sql = 'UPDATE configuration SET valeur = :val WHERE constante = :const';
			$req = $db->prepare($sql);
			$req->bindParam('val', $val, PDO::PARAM_STR);
			$req->bindParam('const', $const, PDO::PARAM_STR);
			
			if(!empty($_POST['siteNom']))
			{
				$const = 'SITE_NOM';
				$val = $_POST['siteNom'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(isset($_POST['debugMode']))
			{
				$const = 'DEBUG_MODE';
				$val = ($_POST['debugMode'] == 1) ? 1 : 0;
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['adminLogin']))
			{
				$const = 'ADMIN_LOGIN';
				$val = $_POST['adminLogin'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['adminPassword']))
			{
				$const = 'ADMIN_PASSWORD';
				$val = cryptPass($_POST['adminPassword']);
				
				if($val !== FALSE)
				{
					if(!($req->execute()))
					{
						errReq($sql, $req);
					}
				}
			}
			
			if(isset($_POST['onlyAdmin']))
			{
				$const = 'ONLY_ADMIN_ADD';
				$val = ($_POST['onlyAdmin'] == 1) ? 1 : 0;
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(isset($_POST['fichierValidation']))
			{
				$const = 'FICHIER_VALIDATION';
				$val = ($_POST['fichierValidation'] == 1) ? 1 : 0;
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['fichierTailleMax']))
			{
				$const = 'FICHIER_TAILLE_MAX';
				$val = intval($_POST['fichierTailleMax']);
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(isset($_POST['showHeader']))
			{
				$const = 'SHOW_HEADER';
				$val = ($_POST['showHeader'] == 1) ? 1 : 0;
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(isset($_FILES['logoPath']) AND !empty($_FILES['logoPath']['name']))
			{
				$file = $_FILES['logoPath'];
				$uploadDir = 'theme/';
				$const = 'LOGO_PATH';
		
				if($file['error'] > 0)
				{
					redirection('admin.php?param', 'Une erreur est survenue lors du transfert de l\'image.');
				}
				else
				{
					if($file['size'] > 5*1024*1024)
					{
						redirection('admin.php?param', 'Le fichier est trop lourd. Taille maximale autorisée : 5 Mo.');
					}
					else
					{
						if($file['type'] == 'image/jpeg' OR $file['type'] == 'image/png')
						{
							if(is_file($uploadDir.$file['name']))
							{
								unlink($uploadDir.$file['name']);
							}
						
							if(move_uploaded_file($file['tmp_name'], $uploadDir.$file['name']))
							{
								$val = $file['name'];
							
								if(!($req->execute()))
								{
									errReq($sql, $req);
									redirection('admin.php?param', 'Une erreur est survenue lors du transfert de l\'image.');
								}
							}
							else
							{
								redirection('admin.php?param', 'Une erreur est survenue lors du transfert de l\'image.');
							}
						}
						else
						{
							redirection('admin.php?param', 'Seules les images au format jpg ou png sont autorisées.');
						}
					}
				}
			}
			
			if(isset($_POST['showLogo']))
			{
				$const = 'SHOW_LOGO';
				$val = ($_POST['showLogo'] == 1) ? 1 : 0;
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['headerC']))
			{
				$const = 'HEADER_COULEUR';
				$val = $_POST['headerC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['titreC']))
			{
				$const = 'TITRE_COULEUR';
				$val = $_POST['titreC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['menuC']))
			{
				$const = 'MENU_COULEUR';
				$val = $_POST['menuC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['menuTexteC']))
			{
				$const = 'MENU_TEXTE_COULEUR';
				$val = $_POST['menuTexteC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['lienC']))
			{
				$const = 'LIEN_COULEUR';
				$val = $_POST['lienC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['lienSurvolC']))
			{
				$const = 'LIEN_SURVOL_COULEUR';
				$val = $_POST['lienSurvolC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			if(!empty($_POST['boutonC']))
			{
				$const = 'BOUTON_COULEUR';
				$val = $_POST['boutonC'];
				
				if(!($req->execute()))
				{
					errReq($sql, $req);
				}
			}
			
			redirection('admin.php?param', 'Modifications enregistrées.');
		}
		?>
		
		<div id="corps">
			<h2>Paramètres</h2>
			
			<div id="option">
				<a href="admin.php">Retour à l'espace d'administration</a>
				<br><br>
			</div>
			
			<form method="POST" action="admin.php?param" enctype="multipart/form-data">
				<fieldset>
					<legend>Paramètres généraux</legend>
					
					<label for="siteNom">Nom du site</label>
					<input type="text" name="siteNom" id="siteNom" value="<?php echo SITE_NOM; ?>">
					<br>
					<label for="debugMode">Mode débogage</label>
					<select name="debugMode" id="debugMode">
						<option value="1" <?php if(DEBUG_MODE){ echo 'selected'; } ?>>Activé</option>
						<option value="0" <?php if(!DEBUG_MODE){ echo 'selected'; } ?>>Désactivé</option>
					</select>
					<br>
					<label for="adminLogin">Identifiant de l'administrateur</label>
					<input type="text" name="adminLogin" id="adminLogin" value="<?php echo ADMIN_LOGIN; ?>">
					<br>
					<label for="adminPassword">Mot de passe de l'administrateur (laisser vide pour ne pas le modifier)</label>
					<input type="password" name="adminPassword" id="adminPassword">
					<br>
					<label for="onlyAdmin">Restreindre l'envoi des fichiers à l'administrateur</label>
					<select name="onlyAdmin" id="onlyAdmin">
						<option value="1" <?php if(ONLY_ADMIN_ADD){ echo 'selected'; } ?>>Activé</option>
						<option value="0" <?php if(!ONLY_ADMIN_ADD){ echo 'selected'; } ?>>Désactivé</option>
					</select>
					<br>
					<label for="fichierValidation">Validation des fichiers envoyés</label>
					<select name="fichierValidation" id="fichierValidation">
						<option value="1" <?php if(FICHIER_VALIDATION){ echo 'selected'; } ?>>Activé</option>
						<option value="0" <?php if(!FICHIER_VALIDATION){ echo 'selected'; } ?>>Désactivé</option>
					</select>
					<br>
					<label for="fichierTailleMax">Taille maximale des fichiers envoyés (en Mo)</label>
					<input type="text" name="FichierTailleMax" id="fichierTailleMax" value="<?php echo FICHIER_TAILLE_MAX; ?>">
				</fieldset>
				
				<fieldset>
					<legend>Thème</legend>
					
					<label for="showHeader">Affichage de l'en-tête</label>
					<select name="showHeader" id="showHeader">
						<option value="1" <?php if(SHOW_HEADER){ echo 'selected'; } ?>>Activé</option>
						<option value="0" <?php if(!SHOW_HEADER){ echo 'selected'; } ?>>Désactivé</option>
					</select>
					<br>
					<label for="logoPath">Logo (Format : jpg/png - Poids max : 5Mo - Hauteur recommandée : 100px) : </label>
					<input type="file" id="logoPath" name="logoPath">
					<br><br>
					<label for="showLogo">Affichage du logo</label>
					<select name="showLogo" id="showLogo">
						<option value="1" <?php if(SHOW_LOGO){ echo 'selected'; } ?>>Activé</option>
						<option value="0" <?php if(!SHOW_LOGO){ echo 'selected'; } ?>>Désactivé</option>
					</select>
					<br>
					<label for="headerC">Couleur de fond de l'en-tête</label>
					<input type="text" name="headerC" id="headerC" value="<?php echo HEADER_COULEUR; ?>">
					<br>
					<label for="titreC">Couleur du titre</label>
					<input type="text" name="titreC" id="titreC" value="<?php echo TITRE_COULEUR; ?>">
					<br>
					<label for="menu">Couleur de fond du menu</label>
					<input type="text" name="menuC" id="menuC" value="<?php echo MENU_COULEUR; ?>">
					<br>
					<label for="menuTexteC">Couleur du texte du menu</label>
					<input type="text" name="menuTexteC" id="menuTexteC" value="<?php echo MENU_TEXTE_COULEUR; ?>">
					<br>
					<label for="lienC">Couleur des liens</label>
					<input type="text" name="lienC" id="lienC" value="<?php echo LIEN_COULEUR; ?>">
					<br>
					<label for="lienSurvolC">Couleur lors du survol des liens</label>
					<input type="text" name="lienSurvolC" id="lienSurvolC" value="<?php echo LIEN_SURVOL_COULEUR; ?>">
					<br>
					<label for="boutonC">Couleur de fond des boutons</label>
					<input type="text" name="boutonC" id="boutonC" value="<?php echo BOUTON_COULEUR; ?>">
					<br>
					<input type="submit" value="Enregistrer">
			</form>
		</div>
		
		<?php
	}
	
	
	
	// GESTION DES FICHIERS ISOLES
	
	else if(isset($_GET['fichiers']))
	{
		$url = 'admin.php?fichiers';
		
		$sql = 'SELECT * FROM fichier WHERE dossier IS NULL';
		sqlTri($sql, FALSE);
		
		if($req = $db->query($sql))
		{
			$res = $req->fetchAll();
			?>
			
			<div id="corps">
				<h2>Fichiers isolés</h2>
				
				<div id="option">
					<a href="admin.php">Retour à l'espace d'administration</a>
					<br><br>
				</div>
				
				<table>
					<tr>
						<th><?php echo colonneLien($url, 'Nom', 'nom'); ?></th>
						<th><?php echo colonneLien($url, 'Taille', 'taille'); ?></th>
						<th><?php echo colonneLien($url, 'Date d\'ajout', 'date'); ?></th>
						<th><?php echo colonneLien($url, 'Auteur', 'auteur'); ?></th>
						<th></th>
					</tr>
					
					<?php
					foreach($res AS $k => $r)
					{
						echo '<tr'; if($k%2 != 0){ echo ' class="lignePaire"'; } echo'>';
							echo '<td class="colonneNom">&nbsp;<a href="dl.php?f='.$r['id'].'">'.htmlentities($r['nom'].'.'.$r['extension']).'</a></td>';
							echo '<td>'.formatFileSize($r['taille']).'</td>';
							$date = new DateTime($r['date']);
							echo '<td>'.$date->format('d/m/Y').'</td>';
							echo '<td>'.htmlentities($r['auteur']).'</td>';
							echo '<td>'.displayIcons(1, $r['id']).'</td>';
						echo '</tr>';
					}
					?>
					
				</table>
				
				<?php
				if(count($res) == 0)
				{
					echo '<div class="center"><br>Aucun fichier n\'a été trouvé.</div>';
				}
				?>
			</div>
			
			<?php
		}
		else
		{
			errReq($sql, $req);
			redirection('admin.php', 'Une erreur est survenue.');
		}
	}
	
	
	
	// VALIDATION DES FICHIERS
	
	else if(isset($_GET['valid']) AND FICHIER_VALIDATION)
	{
		if(isset($_GET['f']) AND intval($_GET['f']) > 0)
		{
			$f = intval($_GET['f']);
			
			$sql = 'UPDATE fichier SET validation = 1 WHERE id = :id';
			$req = $db->prepare($sql);
			$req->bindValue('id', $f, PDO::PARAM_INT);
			
			if(!($req->execute()))
			{
				errReq($sql, $req);
				redirection('admin.php?valid', 'Une erreur est survenue.');
			}
		}
		
		$url = 'admin.php?valid';
		
		$sql = 'SELECT f.id, f.nom, f.taille, f.auteur, f.extension, f.date, f.dossier, d.nom AS dossier_nom FROM fichier f JOIN dossier d ON d.id = f.dossier WHERE f.validation = 0';
		sqlTri($sql, FALSE);
		
		if($req = $db->query($sql))
		{
			$res = $req->fetchAll();
			?>
			
			<div id="corps">
				<h2>Fichiers en attente de validation</h2>
				
				<div id="option">
					<a href="admin.php">Retour à l'espace d'administration</a>
					<br><br>
				</div>
				
				<table>
					<tr>
						<th><?php echo colonneLien($url, 'Nom', 'nom'); ?></th>
						<th>Dossier</th>
						<th><?php echo colonneLien($url, 'Taille', 'taille'); ?></th>
						<th><?php echo colonneLien($url, 'Ajout', 'date'); ?></th>
						<th><?php echo colonneLien($url, 'Auteur', 'auteur'); ?></th>
						<th></th>
					</tr>
					
					<?php
					foreach($res AS $k => $r)
					{
						echo '<tr'; if($k%2 != 0){ echo ' class="lignePaire"'; } echo'>';
							echo '<td class="colonneNom">&nbsp;<a href="dl.php?f='.$r['id'].'">'.htmlentities($r['nom'].'.'.$r['extension']).'</a></td>';
							echo '<td><a href="index.php?id='.$r['dossier'].'">'.htmlentities($r['dossier_nom']).'</a></td>';
							echo '<td>'.formatFileSize($r['taille']).'</td>';
							$date = new DateTime($r['date']);
							echo '<td>'.$date->format('d/m/Y').'</td>';
							echo '<td>'.htmlentities($r['auteur']).'</td>';
							echo '<td>'.displayIcons(1, $r['id'], FALSE, TRUE).'</td>';
						echo '</tr>';
					}
					?>
					
				</table>
				
				<?php
				if(count($res) == 0)
				{
					echo '<div class="center"><br>Aucun fichier n\'a été trouvé.</div>';
				}
				?>
			</div>
			
			<?php
		}
		else
		{
			errReq($sql, $req);
			redirection('admin.php', 'Une erreur est survenue.');
		}
	}
	
	
	
	// PAGE PRINCIPALE
	
	else
	{
		?>
		<div id="corps">
			
			<h2>Espace d'administration</h2>
			
			<div id="option">
				<a href="index.php">Retour à l'accueil</a> 
				<br><br><br>
				<a href="admin.php?param">Paramètres</a> 
				<br><br>
				<a href="admin.php?fichiers">Gérer les fichiers isolés</a> 
				<?php
				if(FICHIER_VALIDATION){ echo '<br><br><a href="admin.php?valid">Valider les fichiers envoyés</a>'; }
				?>
				<br><br><br>
				<a href="admin.php?deconnexion">Déconnexion</a>
			</div>
			
			
			
		</div>
		<?php
	}
}



// CONNEXION

else
{
	?>
	
	<div id="corps">
		
		<h2>Connexion</h2>
		
		<div id="option">
			<a href="index.php">Retour à l'accueil</a>
		</div>
		
		<form method="POST" action="admin.php">
		
			<label for="login">Identifiant</label>
			<input type="text" name="login" id="login" required>
			<br>
			<label for="password">Mot de passe</label>
			<input type="password" name="password" id="password" required>
			<br>
			<input type="submit" value="Connexion">
		
		</form>
	</div>
	
	<?php
}

require_once 'library/footerContent.php';
?>

<script>
// CONFIRMATION AVANT SUPPRESSION

$('.delF').click(function(event)
{
	if(!confirm('Ce fichier va être supprimé. Cette action est irréversible. Continuer ?'))
	{
		event.preventDefault();
	}
});
</script>

</body>
</html>

<?php
ob_end_flush();
?>

