<?php

/***

Sciurus - Bérenger THOMAS
30.03.15

Page de téléchargement

*/


require_once 'library/main.php';

$temp = new DirectoryIterator('temp');
foreach($temp as $fichier)
{
	if($fichier->isFile() AND !$fichier->isDot() AND (time() - $fichier->getMTime() > 60*60*24))
	{
		unlink($fichier->getPathname());
	}
}

if(isset($_GET['f']) AND intval($_GET['f']) > 0)
{
	$d = (isset($_GET['d']) AND intval($_GET['d']) > 0) ? intval($_GET['d']) : 1;
	$f = intval($_GET['f']);
	
	$sql = 'SELECT nom, extension, taille FROM fichier WHERE id = :id LIMIT 1';
	$req = $db->prepare($sql);
	$req->bindValue('id', $f, PDO::PARAM_INT);
	
	if($req->execute())
	{
		if($res = $req->fetch())
		{
			if(is_file('upload/'.$f.'.'.$res['extension']))
			{
				if(isset($_GET['pdf']) AND checkConvert($res['extension']))
				{
					if(!is_file('temp/'.$f.'.pdf'))
					{
						$extension = strtolower($res['extension']);
						
						if(in_array($extension, array('doc', 'docx', 'odt')))
						{
							system("unoconv -d document -o temp/$f.pdf upload/$f.{$res['extension']}");
						}
						else if(in_array($extension, array('ppt', 'pptx', 'odp')))
						{
							system("unoconv -d presentation -o temp/$f.pdf upload/$f.{$res['extension']}");
						}
						else if(in_array($extension, array('xls', 'xlsx', 'ods')))
						{
							system("unoconv -d spreadsheet -o temp/$f.pdf upload/$f.{$res['extension']}");
						}
					}
					
					if(is_file('temp/'.$f.'.pdf'))
					{
						$sql = 'UPDATE fichier SET telechargement = (telechargement + 1) WHERE id = :id';
						$req = $db->prepare($sql);
						$req->bindValue('id', $f, PDO::PARAM_INT);
				
						if(!($req->execute()))
						{
							errReq($sql, $req);
						}
						
						header('Content-Transfer-Encoding: binary');
						header('Content-Type: application/octet-stream');
						header('Content-Disposition: attachment; filename="'.$res['nom'].'.pdf"');
						readfile('temp/'.$f.'.pdf');
					}
					else
					{
						redirection('index.php?d='.$d, 'Une erreur est survenue lors de la génération du PDF.');
					}
				}
				else
				{
					$sql = 'UPDATE fichier SET telechargement = (telechargement + 1) WHERE id = :id';
					$req = $db->prepare($sql);
					$req->bindValue('id', $f, PDO::PARAM_INT);
				
					if(!($req->execute()))
					{
						errReq($sql, $req);
					}
				
					header('Content-Transfer-Encoding: binary');
					header('Content-Type: application/octet-stream');
					header('Content-Disposition: attachment; filename="'.$res['nom'].'.'.$res['extension'].'"');
					header('Content-Length: '.$res['taille']);
					readfile('upload/'.$f.'.'.$res['extension']);
				}
			}
			else
			{
				redirection('index.php?d='.$d, 'Ce fichier n\'existe pas.');
			}
		}
		else
		{
			redirection('index.php?d='.$d, 'Ce fichier n\'existe pas.');
		}
	}
	else
	{
		errReq($sql, $req);
		redirection('index.php?d='.$d, 'Une erreur est survenue lors de la récupération du fichier.');
	}
}
else if(isset($_GET['multi']))
{
	$d = (isset($_GET['d']) AND intval($_GET['d']) > 0) ? intval($_GET['d']) : 1;
	$fichiers = explode('-', $_GET['multi']);
	$id = 0;
	
	if(is_file('temp/fichiers.zip'))
	{
		unlink('temp/fichiers.zip');
	}
	
	$zip = new ZipArchive();
	if($zip->open('temp/fichiers.zip', ZIPARCHIVE::CREATE))
    {
		$sql = 'SELECT nom, extension FROM fichier WHERE id = :id';
		$req = $db->prepare($sql);
		$req->bindParam('id', $id, PDO::PARAM_INT);
	
		$sql2 = 'UPDATE fichier SET telechargement = (telechargement+1) WHERE id = :id';
		$req2 = $db->prepare($sql2);
		$req2->bindParam('id', $id, PDO::PARAM_INT);
	
		foreach($fichiers AS $f)
		{
			$id = intval($f);
			
			if($req->execute())
			{
				if($res = $req->fetch() AND is_file('upload/'.$id.'.'.$res['extension']))
				{
					if(!($req2->execute()))
					{
						errReq($sql2, $req2);
					}
					
					$zip->addFile('upload/'.$id.'.'.$res['extension'], str_replace('\\', '_', $res['nom']).'.'.$res['extension']);
				}				
			}
			else
			{
				errReq($sql, $req);
			}
		}
		
		$zip->close();
		
		header('Content-Transfer-Encoding: binary');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename="fichiers.zip"');
		readfile('temp/fichiers.zip');
    }
    else
    {
    	redirection('index.php?d='.$d, 'Une erreur est survenue.');
    }
}
else
{
	redirection('index.php?d='.$d, 'Ce fichier n\'existe pas.');
}

?>
