<?php

/***

Sciurus - Bérenger THOMAS
28.03.15

Page principale

*/


require_once 'library/main.php';
require_once 'library/header.php';



// INITIALISATION

$id = (isset($_GET['id']) AND intval($_GET['id']) > 0) ? intval($_GET['id']) : 1;
if(!isset($_GET['tri'])){ $_GET['tri'] = 'nom'; }

$contenu = array();
$arboBrute = array();
$arboParents = array();
$arborescence = arborescence($id, $arboBrute, $arboParents);



// RECHERCHE

if(!empty($_GET['r']))
{
	$url = 'index.php?id='.$id.'&r='.$_GET['r'];
	$dossiersRecherche = arborescence($id, $arboBrute, $arboParents, TRUE);
	
	$sql = 'SELECT * FROM fichier WHERE nom LIKE :r OR description LIKE :r OR auteur LIKE :r';
	sqlTri($sql);
	
	$req = $db->prepare($sql);
	$req->bindValue('r', '%'.urldecode($_GET['r']).'%', PDO::PARAM_STR);
	
	if($req->execute())
	{
		while($res = $req->fetch())
		{
			if(in_array($res['dossier'], $dossiersRecherche))
			{
				$contenu[] = $res;
			}
		}
	}
	else
	{
		errReq($sql, $req);
	}
}



// CONTENU D'UN DOSSIER

else
{
	$url = 'index.php?id='.$id;
	
	if($id != 1)
	{
		$contenu[] = ['id' => $arboParents[$id], 'nom' => '...', 'parent' => 0];
	}
	
	$sql = 'SELECT * FROM dossier WHERE parent = :parent ORDER BY nom';
	
	$req = $db->prepare($sql);
	$req->bindValue('parent', $id, PDO::PARAM_INT);
	
	if($req->execute())
	{
		while($res = $req->fetch())
		{
			$contenu[] = $res;
		}
		
		$sql = 'SELECT * FROM fichier WHERE dossier = :id';
		sqlTri($sql);
		
		$req = $db->prepare($sql);
		$req->bindValue('id', $id, PDO::PARAM_INT);
		
		if($req->execute())
		{
			while($res = $req->fetch())
			{
				$contenu[] = $res;
			}
		}
		else
		{
			errReq($sql, $req);
		}
	}
	else
	{
		errReq($sql, $req);
	}
}



// AFFICHAGE

?>

<div id="menu">
	<?php echo $arborescence; ?>
</div>


<div id="contenu">

	<div id="option">
		<?php
		if(!ONLY_ADMIN_ADD OR $_SESSION['admin'])
		{
			echo '<a href="add.php?id='.$id.'">Ajouter un fichier</a> ';
		}
		
		if($_SESSION['admin'])
		{
			echo '<a href="add.php?d&id='.$id.'">Ajouter un dossier</a>';
		}
		?>
		
		<a id="multiDl" href="#">Télécharger la sélection</a>
		
		&nbsp; &nbsp; <form method="GET" action="index.php" id="recherche"><input type="hidden" name="id" value="<?php echo $id; ?>"><input type="text" name="r" placeholder="Recherche"> <button type="submit"><span class="iconSearch"></span></button></form>
		<br>
		<br>
		<?php
		if(!empty($_GET['r']))
		{
			echo '<a href="index.php?id='.$id.'">Retour au dossier</a><br><br>';
		}
		?>
	</div>
	
	
	
	<table>
		<tr>
			<th class="colonneCheck"></th>
			<th class="colonneIcon"></th>
			<th><?php echo colonneLien($url, 'Nom', 'nom'); ?></th>
			<th>Description</th>
			<th><?php echo colonneLien($url, 'Popularité', 'popularite'); ?></th>
			<th class="colonneAccessoire"><?php echo colonneLien($url, 'Taille', 'taille'); ?></th>
			<th class="colonneAccessoire"><?php echo colonneLien($url, 'Date d\'ajout', 'date'); ?></th>
			<th class="colonneAccessoire"><?php echo colonneLien($url, 'Auteur', 'auteur'); ?></th>
			<th class="colonneAccessoire"><?php echo colonneLien($url, 'Téléchargé', 'telechargement'); ?></th>
			<?php if($_SESSION['admin'] == TRUE){ ?> <th></th> <?php } ?>
		</tr>
		
		<?php
		
		$i = 0;
		
		foreach($contenu AS $c)
		{
			if(isset($c['parent']))
			{
				echo '<tr'; if($i%2 != 0){ echo ' class="lignePaire"'; } echo'>';
					echo '<td></td>';
					echo '<td><span class="iconDossier"></span></td>';
					echo '<td class="colonneNom"><a href="index.php?id='.$c['id'].'">'.htmlentities($c['nom']).'</a></td>';
					echo '<td></td>';
					echo '<td></td>';
					echo '<td class="colonneAccessoire"></td>';
					echo '<td class="colonneAccessoire"></td>';
					echo '<td class="colonneAccessoire"></td>';
					echo '<td class="colonneAccessoire"></td>';
					if($_SESSION['admin'])
					{ 
						if($c['parent'] == $id){ echo '<td>'.displayIcons($id, $c['id'], TRUE).'</td>'; }
						else{ echo '<td></td>'; }
					}
				echo '</tr>';
				
				$i++;
			}
			
			else if(FICHIER_VALIDATION == 0 OR $c['validation'] == 1)
			{
				echo '<tr'; if($i%2 != 0){ echo ' class="lignePaire"'; } echo'>';
					echo '<td><input type="checkbox" class="check" data-fichier="'.$c['id'].'"></td>';
					echo '<td><span class="iconFichier"></span></td>';
					echo '<td class="colonneNom"><a href="dl.php?id='.$id.'&f='.$c['id'].'">'.htmlentities($c['nom'].'.'.$c['extension']).'</a>';
					if(checkConvert($c['extension'])){ echo ' (<a href="dl.php?id='.$id.'&f='.$c['id'].'&pdf">PDF</a>)'; }
					echo '</td>';
					echo '<td>'.htmlentities($c['description']).'</td>';
					echo '<td><span class="plus">'.$c['plus'].'</span> <span class="avis" data-avis="p" data-fichier="'.$c['id'].'">(+)</span> / <span class="moins">'.$c['moins'].'</span> <span class="avis" data-avis="m" data-fichier="'.$c['id'].'">(-)</span></td>';
					echo '<td class="colonneAccessoire">'.formatFileSize($c['taille']).'</td>';
					$date = new DateTime($c['date']);
					echo '<td class="colonneAccessoire">'.$date->format('d/m/Y').'</td>';
					echo '<td class="colonneAccessoire">'.htmlentities($c['auteur']).'</td>';
					echo '<td class="colonneAccessoire">'.$c['telechargement'].' fois</td>';
					if($_SESSION['admin'] == TRUE){ echo '<td>'.displayIcons($id, $c['id']).'</td>'; }
				echo '</tr>';
				
				$i++;
			}
		}
		
		?>
	</table>
	
	<?php
	if(count($contenu) == 0)
	{
		echo '<div class="center"><br>Aucun fichier n\'a été trouvé.</div>';
	}
	?>
	
</div>


<?php require_once 'library/footerContent.php'; ?>


<script>

// AFIFICHAGE DU CONTENU D'UN DOSSIER

$('.show').click(function()
{
	if($(this).nextAll('.arborescence:first').css('display') == 'none')
	{
		$(this).nextAll('.arborescence:first').css('display', 'block');
		$(this).html('&#9662;');
	}
	else
	{
		$(this).nextAll('.arborescence:first').css('display', 'none');
		$(this).html('&#9656;');
	}
});



// AVERTISSEMENTS AVANT SUPPRESSION

$('.delD').click(function(event)
{
	if(!confirm('Ce dossier et ses sous-dossiers vont être supprimés. Les fichiers seront déplacés vers la liste des fichiers isolés. Continuer ?'))
	{
		event.preventDefault();
	}
});

$('.delF').click(function(event)
{
	if(!confirm('Ce fichier va être supprimé. Cette action est irréversible. Continuer ?'))
	{
		event.preventDefault();
	}
});



// SAUVEGARDE +/-

$('.avis').click(function()
{
	if($(this).data('fichier') !== undefined && $(this).data('avis') !== undefined)
	{
		var avis = $(this);
		
		var jqxhr = $.get('library/ajax.php?f='+encodeURIComponent($(this).data('fichier'))+'&type='+encodeURIComponent($(this).data('avis')));
		jqxhr.done(function(data)
		{
			$(avis).prev().text(parseInt($(avis).prev().text())+1)
			alert(data);
		});
		jqxhr.fail(function()
		{
			alert('Une erreur est survenue, merci de réessayer.');
		});
	}
	else
	{
		alert('Paramètres incorrects.');
	}
});



// SELECTION D'UN FICHIER

$('.check').change(function()
{
	var multi = false;
	
	$('.check').each(function()
	{
		if($(this).prop('checked'))
		{
			multi = true;
		}
	});
	
	if(multi)
	{
		$('#multiDl').show();
	}
	else
	{
		$('#multiDl').hide();
	}
});



// TELECHARGEMENTS MULTIPLES

$('#multiDl').click(function(event)
{
	event.preventDefault();
	var fichiers = '';
	
	$('.check:checked').each(function()
	{
		if(fichiers != '')
		{
			fichiers += '-';
		}
		fichiers += parseInt($(this).data('fichier'));
	});
	
	if(fichiers != '')
	{
		window.location.assign('dl.php?id='+<?php echo $id; ?>+'&multi='+fichiers);
	}
});

</script>


</body>
</html>

<?php ob_end_flush(); ?>

