<?php

/***

Sciurus - Bérenger THOMAS

Page d'initialisation de la plateforme

*/

mb_internal_encoding("UTF-8");
require_once 'library/fonctions.php';

?>

<!DOCTYPE html>

<html lang="fr">

<head>
	<meta http-equiv="Content-type" content="text/html;charset=utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta name="description" content="Sciurus - Partage de fichiers">
	<meta name="keywords" content="sciurus, partage, fichiers, fiches">
	<meta name="author" content="Bérenger THOMAS">
	<meta name="robots" content="index, nofollow">

	<script type="text/javascript" src="http://code.jquery.com/jquery-latest.min.js"></script>

	<link rel="stylesheet" type="text/css" href="theme/main.css">

	<title>Sciurus - Configuration</title>
</head>

<body>
	<div id="header">
		<div>
			<div id="logo">
				<img src="theme/logo.png" alt="Logo" height="100px"></a>
			</div>
			
			<div id="headerTitre">
				<h1>Sciurus - Configuration</h1>
			</div>
		</div>
	</div>
	<div id="headerSpacer"></div>
	
	<div id="corps">
	
	<?php
	
	if(is_file('library/config.php'))
	{
		?>
		
		<p class="center">Sciurus est déjà configuré.</p>
		
		<?php
	}
	else
	{
		if(isset($_POST['host']))
		{
			if(!empty($_POST['host']) AND !empty($_POST['db']) AND !empty($_POST['user']) AND isset($_POST['password']))
			{
				$host = htmlentities($_POST['host']);
				$database = htmlentities($_POST['db']);
				$user = $_POST['user'];
				$password = $_POST['password'];
			}
			else
			{
				$erreur = 'Formulaire incomplet (Section "Base de données").';
			}
			
			if(!empty($_POST['url']) AND !empty($_POST['nom']) AND !empty($_POST['adminLogin']) AND !empty($_POST['adminPassword']))
			{
				$url = $_POST['url'];
				$nom = $_POST['nom'];
				$adminLogin = $_POST['adminLogin'];
				$adminPassword = $_POST['adminPassword'];
				$onlyAdmin = (isset($_POST['onlyAdmin'])) ? 1 : 0;
				$taille = (intval($_POST['taille']) > 0) ? intval($_POST['taille']) : 30;
				$validation = (isset($_POST['validation'])) ? 1 : 0;
				$pdf = (isset($_POST['pdf'])) ? 1 : 0;
				
				$adminPassword = cryptPass($adminPassword);
				if($adminPassword === FALSE)
				{
					$erreur = 'Une erreur est survenue lors du cryptage du mot de passe.';
				}
			}
			else
			{
				$erreur = 'Formulaire incomplet (Section "Paramètres").';
			}
			
			if(!isset($erreur))
			{
				try
				{
					$db = new PDO('mysql:host='.$host.';dbname='.$database, $user, $password);
					$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
					$db->exec('SET NAMES utf8');
				}
				catch (Exception $e)
				{
					$erreur = 'Impossible de se connecter à la base de données.<br>'.$e -> getMessage();
				}
				
				if(!isset($erreur))
				{
					$path = 'library/config.php';
	
					if($config = fopen($path, 'a+'))
					{
						$txt = '<?php'.PHP_EOL;
						$txt .= PHP_EOL;
						$txt .= '// Fichier de configuration généré automatiquement.'.PHP_EOL;
						$txt .= PHP_EOL;
						$txt .= '$host = \''.str_replace("'", "\\'", $host).'\';'.PHP_EOL;
						$txt .= '$user = \''.str_replace("'", "\\'", $user).'\';'.PHP_EOL;
						$txt .= '$password = \''.str_replace("'", "\\'", $password).'\';'.PHP_EOL;
						$txt .= '$database = \''.str_replace("'", "\\'", $database).'\';'.PHP_EOL;
						$txt .= PHP_EOL;
						$txt .= '?>'.PHP_EOL;
						
						if(!fputs($config, $txt))
						{
							$erreur = 'Une erreur est survenue lors de l\'écriture du fichier de configuration.';
						}
						
						fclose($config);
					}
					else
					{
						$erreur = 'Une erreur est survenue lors de la création du fichier de configuration.';
					}
					
					if(!isset($erreur))
					{
						$sql = 'SET FOREIGN_KEY_CHECKS=0;
								SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
								SET time_zone = "+00:00";';
					
						$sql .= "CREATE TABLE IF NOT EXISTS `configuration` (
								  `id` int(11) NOT NULL,
								  `constante` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
								  `valeur` text COLLATE utf8_unicode_ci NOT NULL
								) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
								
								INSERT INTO `configuration` (`id`, `constante`, `valeur`) VALUES
								(1, 'ROOT_URL', :url),
								(2, 'SITE_NOM', :nom),
								(3, 'DEBUG_MODE', 0),
								(4, 'ADMIN_LOGIN', :adminLogin),
								(5, 'ADMIN_PASSWORD', :adminPass),
								(6, 'ONLY_ADMIN_ADD', :onlyAdmin),
								(7, 'FICHIER_VALIDATION', :validation),
								(8, 'FICHIER_TAILLE_MAX', :taille),
								(9, 'CONVERSION_PDF', :pdf),
								(10, 'SHOW_HEADER', '1'),
								(11, 'LOGO_PATH', 'logo.png'),
								(12, 'SHOW_LOGO', '1'),
								(13, 'HEADER_COULEUR', '#CCDDFF'),
								(14, 'TITRE_COULEUR', '#114477'),
								(15, 'MENU_COULEUR', '#116699'),
								(16, 'MENU_TEXTE_COULEUR', '#FFFFFF'),
								(17, 'LIEN_COULEUR', '#226699'),
								(18, 'LIEN_SURVOL_COULEUR', '#4488DD'),
								(19, 'BOUTON_COULEUR', '#AACCFF');
								
								CREATE TABLE IF NOT EXISTS `dossier` (
								  `id` int(11) NOT NULL,
								  `nom` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
								  `parent` int(11) NOT NULL
								) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
								
								INSERT INTO `dossier` (`id`, `nom`, `parent`) VALUES
								(0, '-', 0),
								(1, 'Racine', 0);
								
								CREATE TABLE IF NOT EXISTS `fichier` (
								  `id` int(11) NOT NULL,
								  `nom` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
								  `extension` varchar(5) COLLATE utf8_unicode_ci NOT NULL,
								  `description` varchar(300) COLLATE utf8_unicode_ci NOT NULL,
								  `dossier` int(11) DEFAULT '1',
								  `taille` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
								  `date` datetime NOT NULL,
								  `telechargement` int(11) NOT NULL DEFAULT '0',
								  `plus` mediumint(9) NOT NULL DEFAULT '0',
								  `moins` mediumint(9) NOT NULL DEFAULT '0',
								  `auteur` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
								  `ip` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
								  `validation` tinyint(4) NOT NULL DEFAULT '0'
								) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
								
								ALTER TABLE `configuration`
								  ADD PRIMARY KEY (`id`);
								
								ALTER TABLE `dossier`
								  ADD PRIMARY KEY (`id`), ADD KEY `parent` (`parent`);
								
								ALTER TABLE `fichier`
								  ADD PRIMARY KEY (`id`), ADD KEY `dossier` (`dossier`);
								
								ALTER TABLE `configuration`
								  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=19;
								ALTER TABLE `dossier`
								  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
								ALTER TABLE `fichier`
								  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;
								
								ALTER TABLE `dossier`
								ADD CONSTRAINT `fk.parent` FOREIGN KEY (`parent`) REFERENCES `dossier` (`id`) ON DELETE CASCADE ON UPDATE NO ACTION;
								
								ALTER TABLE `fichier`
								ADD CONSTRAINT `fk.dossier` FOREIGN KEY (`dossier`) REFERENCES `dossier` (`id`) ON DELETE SET NULL ON UPDATE NO ACTION;
								SET FOREIGN_KEY_CHECKS=1;";
						
						$req = $db->prepare($sql);
						$req->bindValue('url', $url, PDO::PARAM_STR);
						$req->bindValue('nom', $nom, PDO::PARAM_STR);
						$req->bindValue('adminLogin', $adminLogin, PDO::PARAM_STR);
						$req->bindValue('adminPass', $adminPassword, PDO::PARAM_STR);
						$req->bindValue('onlyAdmin', $onlyAdmin, PDO::PARAM_INT);
						$req->bindValue('validation', $validation, PDO::PARAM_INT);
						$req->bindValue('taille', $taille, PDO::PARAM_INT);
						$req->bindValue('pdf', $pdf, PDO::PARAM_INT);
						
						if($req->execute())
						{
							?>
							
							<p class="center">
								Sciurus est maintenant configuré.
								<br><br>
								<a href="index.php">Aller à l'accueil</a>
							</p>
							
							</div>
							
							<div id="footer">
								Sciurus 1.0 - 2015 - Bérenger THOMAS
							</div>
							</body>
							
							</html>
							
							<?php
							exit();
						}
						else
						{
							errReq($sql, $req);
							$erreur = 'Une erreur est survenue lors de la création des tables dans la base de données.';
						}
					}
				}
			}
		}
		
		if(isset($erreur))
		{
			echo '<p class="center bold">'.$erreur.'</p>';
		}
		
		?>
		
		<form method="POST">
			<fieldset>
				<legend>Base de données</legend>
				
				<label for="host">Hôte</label>
				<input type="text" name="host" id="host" required value="<?php echo (isset($_POST['host'])) ? htmlentities($_POST['host']) : 'localhost'; ?>">
				<br>
				<label for="db">Base de données</label>
				<input type="text" name="db" id="db" required value="<?php echo (isset($_POST['db'])) ? htmlentities($_POST['db']) : ''; ?>">
				<br>
				<label for="user">Utilisateur</label>
				<input type="text" name="user" id="user" required value="<?php echo (isset($_POST['user'])) ? htmlentities($_POST['user']) : ''; ?>">
				<br>
				<label for="password">Mot de passe</label>
				<input type="password" name="password" id="password">
				<br>
				
			</fieldset>
			
			<fieldset>
				<legend>Paramètres</legend>
				
				<label for="url">URL du site</label>
				<input type="text" name="url" id="url" required value="<?php echo (isset($_POST['url'])) ? htmlentities($_POST['url']) : 'http://'; ?>">
				<br>
				<label for="nom">Nom du site</label>
				<input type="text" name="nom" id="nom" required value="<?php echo (isset($_POST['nom'])) ? htmlentities($_POST['nom']) : 'Sciurus'; ?>">
				<br>
				<label for="adminLogin">Identifiant de l'administrateur</label>
				<input type="text" name="adminLogin" id="adminLogin" required value="<?php echo (isset($_POST['adminLogin'])) ? htmlentities($_POST['adminLogin']) : 'admin'; ?>">
				<br>
				<label for="adminPassword">Mot de passe de l'administrateur</label>
				<input type="password" name="adminPassword" id="adminPassword" required>
				<br>
				<label for="taille">Taille maximum des fichiers envoyés (en Mo)</label>
				<input type="text" name="taille" id="taille" required value="<?php echo (isset($_POST['taille'])) ? htmlentities($_POST['taille']) : 30; ?>">
				<br>
				<input type="checkbox" name="onlyAdmin" id="onlyAdmin" <?php if(isset($_POST['onlyAdmin'])){ echo 'checked'; } ?>>
				<label for="onlyAdmin">Restreindre l'envoi des fichiers à l'administrateur.</label>
				<br>
				<br>
				<input type="checkbox" name="validation" id="validation" <?php if(isset($_POST['validation'])){ echo 'checked'; } ?>>
				<label for="validation">Activer la validation des fichiers envoyés.</label>
				<br>
				<br>
				<input type="checkbox" name="pdf" id="pdf" <?php if(isset($_POST['pdf'])){ echo 'checked'; } ?>>
				<label for="pdf">Autoriser la conversion en PDF pour les fichiers compatibles.</label> (Nécessite d'installer les paquets unoconv et libreoffice)</br>
			</fieldset>
			
			<input type="submit" value="Enregistrer la configuration">
		</form>
		
		<?php
	}

	?>
	
	</div>
	
	<div id="footer">
		Sciurus 1.1 - 2015 - Bérenger THOMAS
	</div>
</body>

</html>

