<?php

/***

Sciurus - Bérenger THOMAS
28.03.15

Fonctions

*/



// SAUVEGARDE ERREUR REQUÊTE

function errReq ($sql, $req)
{
	$date = date('d-m-Y H:i:s');
	$page = $_SERVER['PHP_SELF'];
	
	$txt = " \r\nDate : ".$date." | Page : ".$page." | Erreur : ".$sql.' ( '.implode(', ', $req -> errorInfo())." ) \r\n";
	
	$path = 'log/err.txt';
	
	if($log = fopen($path, 'a+'))
	{
		if(!fputs($log, $txt))
		{
			return FALSE;
		}
		
		fclose($log);
	}
	else
	{
		return FALSE;
	}
}



// REDIRECTION

function redirection ($url, $msg)
{
	$url = urlencode(str_replace('&amp;', '&', $url));
	$msg = urlencode($msg);
	
	header('Location: '.ROOT_URL.'redirection.php?url='.$url.'&msg='.$msg);
	exit();
}



// LIEN DANS L'EN-TETE DES COLONNES

function colonneLien ($page, $titre, $code)
{
	if(is_string($page) AND is_string($titre) AND is_string($code))
	{
		$url = ROOT_URL.$page;
		$url .= (preg_match('#\?#', $page)) ? '&' : '?';
		$url .= 'tri='.urlencode($code);
		$symbole = '';
		
		if(isset($_GET['tri']) AND $_GET['tri'] == $code)
		{
			if(isset($_GET['desc']))
			{
				$symbole = ' &#9650;';
			}
			else
			{
				$url .= '&desc';
				$symbole = ' &#9660;';
			}
		}
		
		return $symbole.' <a href="'.$url.'">'.htmlentities($titre).'</a>';
	}
	else
	{
		return 'n/a';
	}
}



// TRI SQL

function sqlTri (&$sql, $allOptions = TRUE)
{
	if(!empty($_GET['tri']))
	{
		if($_GET['tri'] == 'popularite' AND $allOptions)
		{
			$sql .= ' ORDER BY (plus - moins)';
		}
		else if($_GET['tri'] == 'telechargement' AND $allOptions)
		{
			$sql .= ' ORDER BY telechargement';
		}
		else if($_GET['tri'] == 'taille')
		{
			$sql .= ' ORDER BY taille';
		}
		else if($_GET['tri'] == 'date')
		{
			$sql .= ' ORDER BY date';
		}
		else if($_GET['tri'] == 'auteur')
		{
			$sql .= ' ORDER BY auteur';
		}
		else
		{
			$sql .= ' ORDER BY nom';
		}
		
		if(isset($_GET['desc']))
		{
			$sql .= ' DESC';
		}
		else
		{
			$sql .= ' ASC';
		}
	}
}



// ARBORESCENCE

function arborescence($id, &$arboBrute, &$arboParents, $recherche = FALSE)
{
	global $db;
	$id = intval($id);
	$arborescence = ($id == 0 OR $recherche) ? array() : '';
	
	if(is_array($arboBrute) AND is_array($arboParents))
	{
		if(count($arboParents) == 0)
		{
			$sql = 'SELECT * FROM dossier WHERE id != 0 ORDER BY nom';
		
			if($req = $db->query($sql))
			{
				while($res = $req->fetch())
				{
					$arboBrute[$res['parent']][] = $res;
					$arboParents[$res['id']] = $res['parent'];
				}
			}
			else
			{
				errReq($sql, $req);
			}
		}
		
		if($recherche)
		{
			$actu = ($id == 1) ? $arboBrute[1] : $arboBrute[$arboParents[$id]];
			$niv = 1;
			$i = [$niv => 0];
			
			while($niv > 0)
			{
				$arborescence[] = $actu[$i[$niv]]['id'];
				
				if(isset($arboBrute[$actu[$i[$niv]]['id']]))
				{
					$actu = $arboBrute[$actu[$i[$niv]]['id']];
					$i[$niv]++;
					$niv++;
					$i[$niv] = 0;
				}
				else if(isset($actu[$i[$niv]+1]))
				{
					$i[$niv]++;
				}
				else
				{
					$actu = $arboBrute[$arboParents[$arboParents[$actu[$i[$niv]]['id']]]];
					$niv--;
					
					while($niv > 0 AND !isset($actu[$i[$niv]]))
					{
						$actu = $arboBrute[$arboParents[$arboParents[$actu[$i[$niv]-1]['id']]]];
						$niv--;
					}
				}
			}
		}
		else
		{
			$niv = ($id == 0) ? 0 : 1;
			$nivMin = $niv-1;
			$i = [$niv => 0];
			
			if(isset($arboBrute[$niv]))
			{
				$actu = $arboBrute[$niv];
				
				while($niv > $nivMin)
				{
					if($id == 0)
					{
						$prefixe = '';
					
						for($k = ($nivMin+1) ; $k < $niv ; $k++)
						{
							$prefixe .= '&nbsp; &nbsp; ';
						}
						
						$arborescence[$actu[$i[$niv]]['id']] = $prefixe.htmlentities($actu[$i[$niv]]['nom']);
					}
					else
					{
						if(isset($arboBrute[$actu[$i[$niv]]['id']]))
						{
							$actif = $id;
							$show = FALSE;
			
							while($actif != 1)
							{
								if($actif == $actu[$i[$niv]]['id'])
								{
									$show = TRUE;
									break;
								}
								else
								{
									$actif = $arboParents[$actif];
								}
							}
					
							if($show){ $arborescence .= '<span class="show">&#9662;</span>'; }
							else{ $arborescence .= '<span class="show">&#9656;</span>'; }
						}
						else
						{
							$arborescence .= '<span class="showBloc"></span>';
						}
					
						$arborescence .= ($id == $actu[$i[$niv]]['id']) ? '<a class="bold"' : '<a';
						$arborescence .= ' href="index.php?id='.$actu[$i[$niv]]['id'].'">'.$actu[$i[$niv]]['nom'].'</a><br>';
					}
		
					if(isset($arboBrute[$actu[$i[$niv]]['id']]))
					{
						if($id != 0)
						{
							$arborescence .= '<span class="arborescence"';
							$arborescence .= ($show) ? '>' : ' style="display: none;">';
						}
					
						$actu = $arboBrute[$actu[$i[$niv]]['id']];
						$i[$niv]++;
						$niv++;
						$i[$niv] = 0;
					}
					else if(isset($actu[$i[$niv]+1]))
					{
						$i[$niv]++;
					}
					else
					{
						if($id != 0){ $arborescence .= '</span>'; }
						
						$actu = $arboBrute[$arboParents[$arboParents[$actu[$i[$niv]]['id']]]];
						$niv--;
						
						while($niv > $nivMin AND !isset($actu[$i[$niv]]))
						{
							if($id != 0){ $arborescence .= '</span>'; }
						
							$actu = $arboBrute[$arboParents[$arboParents[$actu[$i[$niv]-1]['id']]]];
							$niv--;
						}
					}
				}
			}
		}
	}
	
	return $arborescence;
}



// VERIFICATION DE LA CONNEXION

function checkLogin()
{
	if(isset($_POST['login']) AND isset($_POST['password']))
	{
		if($_POST['login'] == ADMIN_LOGIN AND crypt($_POST['password'], ADMIN_PASSWORD) == ADMIN_PASSWORD)
		{
			$_SESSION['admin'] = TRUE;
			return TRUE;
		}
	}
	
	return FALSE;
}



// CRYPTAGE MOT DE PASSE

function cryptPass($pass)
{
	$values = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
	$max = mb_strlen($values);
	$salt = '$2y$10$';
	
	for($i = 0 ; $i < 22 ; $i++)
	{
		$salt .= mb_substr($values, mt_rand(0, $max), 1);
	}			
	$salt .= strtr(base64_encode(mcrypt_create_iv(18, MCRYPT_DEV_URANDOM)), '+', '.');
	
	if($passCrypt = crypt($pass, $salt))
	{
		return $passCrypt;
	}
	else
	{
		return FALSE;
	}
}



// FORMATAGE DE LA TAILLE DES FICHIERS

function formatFileSize($size)
{
	$size = intval($size);
	
	$mega = floor($size/1048576);
	$kilo = floor(($size-$mega*1048576)/1024);
	$octet = $size - $mega*1048576 - $kilo*1024;
	
	if($mega > 0)
	{
		return $mega.','.round($kilo/100).' Mo';
	}
	else if($kilo > 0)
	{
		return $kilo.','.round($octet/1024*10).' ko';
	}
	else
	{
		return $octet.' o';
	}
}



// AFFICHAGE DES ICONES DE GESTION

function displayIcons ($dossierActu, $id, $dossier = FALSE, $validation = FALSE)
{
	if($dossier)
	{
		$return = '<a href="add.php?id='.$dossierActu.'&d='.$id.'&edit"><span class="iconEdit"></span></a>';
		$return .= ' <a class="delD" href="add.php?id='.$dossierActu.'&d='.$id.'&del"><span class="iconDel"></span></a>';
	}
	else
	{
		$return = '<a href="add.php?id='.$dossierActu.'&f='.$id.'&edit"><span class="iconEdit"></span></a>';
		if($validation){ $return .= ' <a href="admin.php?valid&f='.$id.'"><span class="iconValid"></span></a>'; }
		$return .= ' <a class="delF" href="add.php?id='.$dossierActu.'&f='.$id.'&del"><span class="iconDel"></span></a>';
	}
	
	return $return;
}



// VERIFICATION PRE-CONVERSION

function checkConvert ($extension)
{
	$extension = strtolower($extension);
	
	if(CONVERSION_PDF AND in_array($extension, array('doc','docx', 'odt', 'ppt', 'pptx', 'odp', 'xls', 'xlsx', 'ods')))
	{
		return TRUE;
	}
	
	return FALSE;
}



// CONVERSION EN PDF




